Index: LMDZ5/branches/testing/libf/phylmd/change_srf_frac_mod.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/change_srf_frac_mod.F90	(revision 2220)
+++ LMDZ5/branches/testing/libf/phylmd/change_srf_frac_mod.F90	(revision 2258)
@@ -1,4 +1,4 @@
 !
-! $Header$
+! $Id$
 !
 MODULE change_srf_frac_mod
@@ -12,5 +12,11 @@
 
   SUBROUTINE change_srf_frac(itime, dtime, jour, &
-       pctsrf, alb1, alb2, tsurf, ustar, u10m, v10m, pbl_tke)
+!albedo SB >>>
+!       pctsrf, alb1, alb2, tsurf, ustar, u10m, v10m, pbl_tke)
+        pctsrf, alb_dir, alb_dif, tsurf, ustar, u10m, v10m, pbl_tke)
+!albedo SB <<<
+   
+
+
 !
 ! This subroutine is called from physiq.F at each timestep. 
@@ -32,4 +38,9 @@
     INCLUDE "iniprint.h"
     INCLUDE "YOMCST.h"
+!albedo SB >>>
+    include "clesphys.h"
+!albedo SB <<<
+
+
 
 ! Input arguments
@@ -43,6 +54,10 @@
    
     REAL, DIMENSION(klon,nbsrf), INTENT(INOUT) :: pctsrf ! sub-surface fraction
-    REAL, DIMENSION(klon,nbsrf), INTENT(INOUT) :: alb1   ! albedo first interval in SW spektrum
-    REAL, DIMENSION(klon,nbsrf), INTENT(INOUT) :: alb2   ! albedo second interval in SW spektrum
+!albedo SB >>>
+!   REAL, DIMENSION(klon,nbsrf), INTENT(INOUT) :: alb1   ! albedo first interval in SW spektrum
+!   REAL, DIMENSION(klon,nbsrf), INTENT(INOUT) :: alb2   ! albedo second interval in SW spektrum
+    REAL, DIMENSION(klon,nsw,nbsrf), INTENT(INOUT) :: alb_dir,alb_dif
+!albedo SB <<<
+
     REAL, DIMENSION(klon,nbsrf), INTENT(INOUT) :: tsurf
     REAL, DIMENSION(klon,nbsrf), INTENT(INOUT) :: ustar
@@ -160,5 +175,12 @@
 ! 
 !****************************************************************************************
-       CALL pbl_surface_newfrac(itime, pctsrf, pctsrf_old, tsurf, alb1, alb2, ustar, u10m, v10m, pbl_tke)
+
+!albedo SB >>>
+! CALL pbl_surface_newfrac(itime, pctsrf, pctsrf_old, tsurf, alb1, alb2, ustar,
+! u10m, v10m, pbl_tke)
+       CALL pbl_surface_newfrac(itime, pctsrf, pctsrf_old, tsurf, alb_dir,alb_dif, ustar, u10m, v10m, pbl_tke)
+!albedo SB <<<
+
+
 
     ELSE
Index: LMDZ5/branches/testing/libf/phylmd/clcdrag.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/clcdrag.F90	(revision 2220)
+++ LMDZ5/branches/testing/libf/phylmd/clcdrag.F90	(revision 2258)
@@ -61,4 +61,9 @@
   REAL, DIMENSION(klon) :: zgeop1       ! geopotentiel au 1er niveau du modele
   LOGICAL, PARAMETER    :: zxli=.FALSE. ! calcul des cdrags selon Laurent Li
+
+  CHARACTER (LEN=80) :: abort_message
+  CHARACTER (LEN=20) :: modname = 'clcdrag'
+
+
 !
 ! Fonctions thermodynamiques et fonctions d'instabilite
@@ -66,4 +71,9 @@
   fsta(x) = 1.0 / (1.0+10.0*x*(1+8.0*x))
   fins(x) = SQRT(1.0-18.0*x)
+
+  abort_message='obsolete, remplace par cdrag, use at you own risk'
+  CALL abort_gcm(modname,abort_message,1)
+
+
 
 ! ================================================================= c
Index: LMDZ5/branches/testing/libf/phylmd/clesphys.h
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/clesphys.h	(revision 2220)
+++ LMDZ5/branches/testing/libf/phylmd/clesphys.h	(revision 2258)
@@ -74,5 +74,6 @@
        REAL freq_COSP
        LOGICAL :: ok_cosp,ok_mensuelCOSP,ok_journeCOSP,ok_hfCOSP
-       INTEGER :: ip_ebil_phy, iflag_rrtm, iflag_ice_thermo,NSW
+       INTEGER :: ip_ebil_phy, iflag_rrtm, iflag_ice_thermo, NSW, iflag_albedo
+       LOGICAL :: ok_chlorophyll
        LOGICAL :: ok_strato
        LOGICAL :: ok_hines, ok_gwd_rando
@@ -116,6 +117,6 @@
      &     , ok_lic_melt,           aer_type                            &
      &     , iflag_rrtm, ok_strato,ok_hines, ok_qch4                    &
-     &     , iflag_ice_thermo, ok_gwd_rando, NSW                        &
-     &     , ok_conserv_q, ok_all_xml
+     &     , iflag_ice_thermo, ok_gwd_rando, NSW, iflag_albedo          &
+     &     , ok_chlorophyll,ok_conserv_q, ok_all_xml
      
        save /clesphys/
Index: LMDZ5/branches/testing/libf/phylmd/coefcdrag.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/coefcdrag.F90	(revision 2220)
+++ LMDZ5/branches/testing/libf/phylmd/coefcdrag.F90	(revision 2258)
@@ -64,4 +64,11 @@
       REAL, dimension(klon) :: trm0, trm1
 
+  CHARACTER (LEN=80) :: abort_message
+  CHARACTER (LEN=20) :: modname = 'coefcdra'
+
+
+!
+
+
 !-------------------------------------------------------------------------
       REAL :: fsta, fins, x
@@ -69,4 +76,8 @@
       fins(x) = SQRT(1.0-18.0*x)
 !-------------------------------------------------------------------------
+
+  abort_message='obsolete, remplace par cdrag, use at you own risk'
+  CALL abort_gcm(modname,abort_message,1)
+
 !
       DO i = 1, knon
Index: LMDZ5/branches/testing/libf/phylmd/conf_phys_m.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/conf_phys_m.F90	(revision 2220)
+++ LMDZ5/branches/testing/libf/phylmd/conf_phys_m.F90	(revision 2258)
@@ -15,5 +15,5 @@
        solarlong0,seuil_inversion, &
        fact_cldcon, facttemps,ok_newmicro,iflag_radia,&
-       iflag_cldth, &
+       iflag_cld_th, &
        iflag_ratqs,ratqsbas,ratqshaut,tau_ratqs, &
        ok_ade, ok_aie, ok_cdnc, aerosol_couple, &
@@ -81,5 +81,5 @@
     REAL                 :: bl95_b0, bl95_b1
     real                 :: fact_cldcon, facttemps,ratqsbas,ratqshaut,tau_ratqs
-    integer              :: iflag_cldth
+    integer              :: iflag_cld_th
     integer              :: iflag_ratqs
 
@@ -110,6 +110,8 @@
     integer,SAVE        :: iflag_radia_omp
     integer,SAVE        :: iflag_rrtm_omp
+    integer,SAVE        :: iflag_albedo_omp !albedo SB
+    logical,save        :: ok_chlorophyll_omp ! albedo SB  
     integer,SAVE        :: NSW_omp
-    integer,SAVE        :: iflag_cldth_omp, ip_ebil_phy_omp
+    integer,SAVE        :: iflag_cld_th_omp, ip_ebil_phy_omp
     integer,SAVE        :: iflag_ratqs_omp
 
@@ -889,25 +891,25 @@
     NSW_omp = 6
     call getin('NSW',NSW_omp)
-
-    !
-    !Config Key  = iflag_cldth 
+!albedo SB >>>
+    iflag_albedo_omp = 0
+    call getin('iflag_albedo',iflag_albedo_omp)
+
+    ok_chlorophyll_omp=.false.
+    call getin('ok_chlorophyll',ok_chlorophyll_omp)
+!albedo SB <<<
+
+    !
+    !Config Key  = iflag_cld_th 
     !Config Desc =  
     !Config Def  = 1
     !Config Help = 
     !
-    iflag_cldth_omp = 1
+    iflag_cld_th_omp = 1
 ! On lit deux fois avec l'ancien et le nouveau nom 
 ! pour assurer une retrocompatiblite.
 ! A abandonner un jour
-    call getin('iflag_cldcon',iflag_cldth_omp)
-    call getin('iflag_cldth',iflag_cldth_omp)
-
-    !
-    !Config Key  = iflag_cld_cv
-    !Config Desc =
-    !Config Def  = 1
-    !Config Help =
-    !
-    iflag_cld_cv_omp = 1
+    call getin('iflag_cldcon',iflag_cld_th_omp)
+    call getin('iflag_cld_th',iflag_cld_th_omp)
+    iflag_cld_cv_omp = 0 
     call getin('iflag_cld_cv',iflag_cld_cv_omp)
 
@@ -1973,5 +1975,5 @@
     iflag_rrtm = iflag_rrtm_omp
     NSW = NSW_omp
-    iflag_cldth = iflag_cldth_omp
+    iflag_cld_th = iflag_cld_th_omp
     iflag_cld_cv = iflag_cld_cv_omp
     tau_cld_cv = tau_cld_cv_omp
@@ -2128,5 +2130,5 @@
     write(lunout,*)' reevap_ice = ', reevap_ice
     write(lunout,*)' iflag_pdf = ', iflag_pdf
-    write(lunout,*)' iflag_cldth = ', iflag_cldth
+    write(lunout,*)' iflag_cld_th = ', iflag_cld_th
     write(lunout,*)' iflag_cld_cv = ', iflag_cld_cv
     write(lunout,*)' tau_cld_cv = ', tau_cld_cv
@@ -2135,4 +2137,6 @@
     write(lunout,*)' iflag_rrtm = ', iflag_rrtm
     write(lunout,*)' NSW = ', NSW
+    write(lunout,*)' iflag_albedo = ', iflag_albedo !albedo SB
+    write(lunout,*)' ok_chlorophyll =',ok_chlorophyll ! albedo SB
     write(lunout,*)' iflag_ratqs = ', iflag_ratqs
     write(lunout,*)' seuil_inversion = ', seuil_inversion
Index: LMDZ5/branches/testing/libf/phylmd/cv3p1_closure.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/cv3p1_closure.F90	(revision 2220)
+++ LMDZ5/branches/testing/libf/phylmd/cv3p1_closure.F90	(revision 2258)
@@ -53,5 +53,5 @@
 
   ! local variables:
-  INTEGER il, i, j, k, icbmax, i0(nloc), klfc
+  INTEGER il, i, j, k, icbmax, i0(nloc), klfc(nloc)
   REAL deltap, fac, w, amu
   REAL rhodp
@@ -525,8 +525,11 @@
 
 !CR:Compute k at plfc
+  DO il=1,ncum
+           klfc(il)=nl
+  ENDDO
   DO k=1,nl
      DO il=1,ncum
         if ((plfc(il).lt.ph(il,k)).and.(plfc(il).ge.ph(il,k+1))) then
-           klfc=k
+           klfc(il)=k
         endif
      ENDDO
@@ -540,6 +543,6 @@
 !CR: Add large-scale component to the mass-flux
 !encore connu sous le nom "Experience du tube de dentifrice"
-    if (coef_clos_ls.gt.0.) then 
-       cbmf1(il) = cbmf1(il) - coef_clos_ls*min(0.,1./RG*omega(il,klfc))
+    if ((coef_clos_ls.gt.0.).and.(plfc(il).gt.0.)) then 
+       cbmf1(il) = cbmf1(il) - coef_clos_ls*min(0.,1./RG*omega(il,klfc(il)))
     endif
 !RC
Index: LMDZ5/branches/testing/libf/phylmd/cv3p_mixing.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/cv3p_mixing.F90	(revision 2220)
+++ LMDZ5/branches/testing/libf/phylmd/cv3p_mixing.F90	(revision 2258)
@@ -58,5 +58,6 @@
   REAL, DIMENSION (nloc)             :: Smid, Sjmin, Sjmax
   REAL, DIMENSION (nloc)             :: Sbef, sup, smin
-  REAL, DIMENSION (nloc)             :: ASij, smax, Scrit
+!jyg  REAL, DIMENSION (nloc)             :: ASij, smax, Scrit
+  REAL, DIMENSION (nloc)             :: ASij, ASij_inv, smax, Scrit
   REAL, DIMENSION (nloc, nd, nd)     :: Sij
   REAL, DIMENSION (nloc, nd)         :: csum
@@ -524,5 +525,10 @@
       IF (i>=icb(il) .AND. i<=inb(il) .AND. lwork(il)) THEN
         ASij(il) = amax1(1.0E-16, ASij(il))
-        ASij(il) = 1.0/ASij(il)
+!jyg+lluis<
+!!        ASij(il) = 1.0/ASij(il)
+        ASij_inv(il) = 1.0/ASij(il)
+!   IF the F-interval spanned by possible mixtures is less than 0.01, no mixing occurs
+        IF (ASij_inv(il) > 100.)  ASij_inv(il) = 0.
+!>jyg+lluis
         csum(il, i) = 0.0
       END IF
@@ -533,5 +539,6 @@
         IF (i>=icb(il) .AND. i<=inb(il) .AND. lwork(il) .AND. &
             j>=(icb(il)-1) .AND. j<=inb(il)) THEN
-          Ment(il, i, j) = Ment(il, i, j)*ASij(il)
+!jyg          Ment(il, i, j) = Ment(il, i, j)*ASij(il)
+          Ment(il, i, j) = Ment(il, i, j)*ASij_inv(il)
         END IF
       END DO
Index: LMDZ5/branches/testing/libf/phylmd/etat0_netcdf.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/etat0_netcdf.F90	(revision 2220)
+++ LMDZ5/branches/testing/libf/phylmd/etat0_netcdf.F90	(revision 2258)
@@ -482,4 +482,8 @@
   falb1(:,is_oce) = 0.5;  falb1(:,is_sic) = 0.6
   falb2 = falb1
+!albedo SB >>>
+  falb_dir(:,is_ter,:)=0.08; falb_dir(:,is_lic,:)=0.6
+  falb_dir(:,is_oce,:)=0.5;  falb_dir(:,is_sic,:)=0.6
+!albedo SB <<<
   evap(:,:) = 0.
   DO i=1,nbsrf; qsolsrf(:,i)=150.; END DO
Index: LMDZ5/branches/testing/libf/phylmd/fisrtilp.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/fisrtilp.F90	(revision 2220)
+++ LMDZ5/branches/testing/libf/phylmd/fisrtilp.F90	(revision 2258)
@@ -8,5 +8,5 @@
      frac_impa, frac_nucl, beta,                        &
      prfl, psfl, rhcl, zqta, fraca,                     &
-     ztv, zpspsk, ztla, zthl, iflag_cldth,             &
+     ztv, zpspsk, ztla, zthl, iflag_cld_th,             &
      iflag_ice_thermo)
 
@@ -82,5 +82,5 @@
   INTEGER ninter ! sous-intervals pour la precipitation
   INTEGER ncoreczq  
-  INTEGER iflag_cldth
+  INTEGER iflag_cld_th
   INTEGER iflag_ice_thermo
   PARAMETER (ninter=5)
@@ -545,5 +545,5 @@
            enddo
 
-           if (iflag_cldth>=5) then
+           if (iflag_cld_th>=5) then
 
               call cloudth(klon,klev,k,ztv, &
@@ -559,11 +559,11 @@
            endif
 
-           if (iflag_cldth <= 4) then
+           if (iflag_cld_th <= 4) then
               lognormale = .true.
-           elseif (iflag_cldth >= 6) then
+           elseif (iflag_cld_th >= 6) then
               ! lognormale en l'absence des thermiques
               lognormale = fraca(:,k) < 1e-10
            else
-              ! Dans le cas iflag_cldth=5, on prend systématiquement la
+              ! Dans le cas iflag_cld_th=5, on prend systématiquement la
               ! bi-gaussienne
               lognormale = .false.
@@ -783,9 +783,5 @@
         else if (iflag_fisrtilp_qsat.gt.0) then
            DO i= 1, klon
-             if (lognormale(i)) then
-             zt(i)=Tbef(i)
-             else
              zt(i) = zt(i) + zcond(i) * RLVTT/RCPD/(1.0+RVTMP2*(zq(i)+zcond(i)))
-             endif
            ENDDO
         endif
@@ -800,5 +796,5 @@
 !                                     t_glace_max, exposant_glace)
               if (iflag_t_glace.eq.0) then
-                    zfice(i) = 1.0 - (Tbef(i)-t_glace_min_old) / (RTT-t_glace_min_old)
+                    zfice(i) = 1.0 - (zt(i)-t_glace_min_old) / (RTT-t_glace_min_old)
                     zfice(i) = MIN(MAX(zfice(i),0.0),1.0)
                     zfice(i) = zfice(i)**exposant_glace_old
@@ -809,12 +805,9 @@
          else
            DO i=1, klon
-              if (lognormale(i)) then
-                 zt(i)=Tbef(i)
-              else
 ! JBM: icefrac_lsc is now a function contained in icefrac_lsc_mod
 !              zfice(i) = icefrac_lsc(zt(i), t_glace_min, &
 !                                     t_glace_max, exposant_glace)
               if (iflag_t_glace.eq.0) then
-                    zfice(i) = 1.0 - (Tbef(i)-t_glace_min_old) / (RTT-t_glace_min_old)
+                    zfice(i) = 1.0 - (zt(i)-t_glace_min_old) / (RTT-t_glace_min_old)
                     zfice(i) = MIN(MAX(zfice(i),0.0),1.0)
                     zfice(i) = zfice(i)**exposant_glace_old
@@ -822,5 +815,4 @@
               zt(i) = zt(i) + (1.-zfice(i))*zcond(i) * RLVTT/RCPD/(1.0+RVTMP2*(zq(i)+zcond(i))) &
                        +zfice(i)*zcond(i) * RLSTT/RCPD/(1.0+RVTMP2*(zq(i)+zcond(i)))
-              endif
            ENDDO
          endif
Index: LMDZ5/branches/testing/libf/phylmd/hgardfou.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/hgardfou.F90	(revision 2220)
+++ LMDZ5/branches/testing/libf/phylmd/hgardfou.F90	(revision 2258)
@@ -1,5 +1,5 @@
 
 ! $Id$
-SUBROUTINE hgardfou(t, tsol, text)
+SUBROUTINE hgardfou(t, tsol, text,abortphy)
   USE dimphy
   USE phys_state_var_mod
@@ -15,4 +15,5 @@
   CHARACTER(len=*), intent(in):: text
   CHARACTER (LEN=20) :: modname = 'hgardfou'
+  INTEGER abortphy
 
   INTEGER i, k, nsrf
@@ -128,5 +129,6 @@
   END DO
 
-  IF (.NOT. ok) CALL abort_gcm(modname, text, 1)
+!  IF (.NOT. ok) CALL abort_gcm(modname, text, 1)
+  IF (.NOT. ok) abortphy=1
 
 END SUBROUTINE hgardfou
Index: LMDZ5/branches/testing/libf/phylmd/iniphysiq.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/iniphysiq.F90	(revision 2220)
+++ LMDZ5/branches/testing/libf/phylmd/iniphysiq.F90	(revision 2258)
@@ -3,31 +3,28 @@
 
 
-
-SUBROUTINE iniphysiq(ngrid, nlayer, punjours, pdayref, ptimestep, plat, plon, &
-    parea, pcu, pcv, prad, pg, pr, pcpp, iflag_phys)
-  USE dimphy, ONLY: klev
-  USE mod_grid_phy_lmdz, ONLY: klon_glo
-  USE mod_phys_lmdz_para, ONLY: klon_omp, klon_omp_begin, klon_omp_end, &
-    klon_mpi_begin
-  USE comgeomphy, ONLY: airephy, cuphy, cvphy, rlond, rlatd
+SUBROUTINE iniphysiq(iim,jjm,nlayer,punjours, pdayref,ptimestep,         &
+                     rlatu,rlonv,aire,cu,cv,                             &
+                     prad,pg,pr,pcpp,iflag_phys)
+  USE dimphy, ONLY: klev ! number of atmospheric levels
+  USE mod_grid_phy_lmdz, ONLY: klon_glo ! number of atmospheric columns
+                                        ! (on full grid)
+  USE mod_phys_lmdz_para, ONLY: klon_omp, & ! number of columns (on local omp grid)
+                                klon_omp_begin, & ! start index of local omp subgrid
+                                klon_omp_end, & ! end index of local omp subgrid
+                                klon_mpi_begin ! start indes of columns (on local mpi grid)
+  USE comgeomphy, ONLY: initcomgeomphy, &
+                        airephy, & ! physics grid area (m2)
+                        cuphy, & ! cu coeff. (u_covariant = cu * u)
+                        cvphy, & ! cv coeff. (v_covariant = cv * v)
+                        rlond, & ! longitudes
+                        rlatd ! latitudes
   USE phyaqua_mod, ONLY: iniaqua
   IMPLICIT NONE
 
   ! =======================================================================
-
   ! Initialisation of the physical constants and some positional and
   ! geometrical arrays for the physics
-
-
-  ! ngrid                 Size of the horizontal grid.
-  ! All internal loops are performed on that grid.
-  ! nlayer                Number of vertical layers.
-  ! pdayref               Day of reference for the simulation
-
   ! =======================================================================
 
-  ! ym#include "dimensions.h"
-  ! ym#include "dimphy.h"
-  ! ym#include "comgeomphy.h"
   include "YOMCST.h"
   include "iniprint.h"
@@ -38,11 +35,12 @@
   REAL, INTENT (IN) :: pcpp ! specific heat Cp
   REAL, INTENT (IN) :: punjours ! length (in s) of a standard day
-  INTEGER, INTENT (IN) :: ngrid ! number of horizontal grid points in the physics
   INTEGER, INTENT (IN) :: nlayer ! number of atmospheric layers
-  REAL, INTENT (IN) :: plat(ngrid) ! latitudes of the physics grid
-  REAL, INTENT (IN) :: plon(ngrid) ! longitudes of the physics grid
-  REAL, INTENT (IN) :: parea(klon_glo) ! area (m2)
-  REAL, INTENT (IN) :: pcu(klon_glo) ! cu coeff. (u_covariant = cu * u)
-  REAL, INTENT (IN) :: pcv(klon_glo) ! cv coeff. (v_covariant = cv * v)
+  INTEGER, INTENT (IN) :: iim ! number of atmospheric columns along longitudes
+  INTEGER, INTENT (IN) :: jjm ! number of atompsheric columns along latitudes
+  REAL, INTENT (IN) :: rlatu(jjm+1) ! latitudes of the physics grid
+  REAL, INTENT (IN) :: rlonv(iim+1) ! longitudes of the physics grid
+  REAL, INTENT (IN) :: aire(iim+1,jjm+1) ! area of the dynamics grid (m2)
+  REAL, INTENT (IN) :: cu((iim+1)*(jjm+1)) ! cu coeff. (u_covariant = cu * u)
+  REAL, INTENT (IN) :: cv((iim+1)*jjm) ! cv coeff. (v_covariant = cv * v)
   INTEGER, INTENT (IN) :: pdayref ! reference day of for the simulation
   REAL, INTENT (IN) :: ptimestep !physics time step (s)
@@ -50,6 +48,16 @@
 
   INTEGER :: ibegin, iend, offset
+  INTEGER :: i,j
   CHARACTER (LEN=20) :: modname = 'iniphysiq'
   CHARACTER (LEN=80) :: abort_message
+  REAL :: total_area_phy, total_area_dyn
+
+
+  ! global array, on full physics grid:
+  REAL,ALLOCATABLE :: latfi(:)
+  REAL,ALLOCATABLE :: lonfi(:)
+  REAL,ALLOCATABLE :: cufi(:)
+  REAL,ALLOCATABLE :: cvfi(:)
+  REAL,ALLOCATABLE :: airefi(:)
 
   IF (nlayer/=klev) THEN
@@ -62,22 +70,68 @@
   END IF
 
-  IF (ngrid/=klon_glo) THEN
-    WRITE (lunout, *) 'STOP in ', trim(modname)
-    WRITE (lunout, *) 'Problem with dimensions :'
-    WRITE (lunout, *) 'ngrid     = ', ngrid
-    WRITE (lunout, *) 'klon   = ', klon_glo
-    abort_message = ''
-    CALL abort_gcm(modname, abort_message, 1)
-  END IF
-
-  !$OMP PARALLEL PRIVATE(ibegin,iend) &
-  !$OMP          SHARED(parea,pcu,pcv,plon,plat)
+  !call init_phys_lmdz(iim,jjm+1,llm,1,(/(jjm-1)*iim+2/))
+  
+  ! Generate global arrays on full physics grid
+  ALLOCATE(latfi(klon_glo),lonfi(klon_glo),cufi(klon_glo),cvfi(klon_glo))
+  ALLOCATE(airefi(klon_glo))
+
+  IF (klon_glo>1) THEN ! general case
+    ! North pole
+    latfi(1)=rlatu(1)
+    lonfi(1)=0.
+    cufi(1) = cu(1)
+    cvfi(1) = cv(1)
+    DO j=2,jjm
+      DO i=1,iim
+        latfi((j-2)*iim+1+i)= rlatu(j)
+        lonfi((j-2)*iim+1+i)= rlonv(i)
+        cufi((j-2)*iim+1+i) = cu((j-1)*iim+1+i)
+        cvfi((j-2)*iim+1+i) = cv((j-1)*iim+1+i)
+      ENDDO
+    ENDDO
+    ! South pole
+    latfi(klon_glo)= rlatu(jjm+1)
+    lonfi(klon_glo)= 0.
+    cufi(klon_glo) = cu((iim+1)*jjm+1)
+    cvfi(klon_glo) = cv((iim+1)*jjm-iim)
+
+    ! build airefi(), mesh area on physics grid
+    CALL gr_dyn_fi(1,iim+1,jjm+1,klon_glo,aire,airefi)
+    ! Poles are single points on physics grid
+    airefi(1)=sum(aire(1:iim,1))
+    airefi(klon_glo)=sum(aire(1:iim,jjm+1))
+
+    ! Sanity check: do total planet area match between physics and dynamics?
+    total_area_dyn=sum(aire(1:iim,1:jjm+1))
+    total_area_phy=sum(airefi(1:klon_glo))
+    IF (total_area_dyn/=total_area_phy) THEN
+      WRITE (lunout, *) 'iniphysiq: planet total surface discrepancy !!!'
+      WRITE (lunout, *) '     in the dynamics total_area_dyn=', total_area_dyn
+      WRITE (lunout, *) '  but in the physics total_area_phy=', total_area_phy
+      IF (abs(total_area_dyn-total_area_phy)>0.00001*total_area_dyn) THEN
+        ! stop here if the relative difference is more than 0.001%
+        abort_message = 'planet total surface discrepancy'
+        CALL abort_gcm(modname, abort_message, 1)
+      ENDIF
+    ENDIF
+  ELSE ! klon_glo==1, running the 1D model
+    ! just copy over input values
+    latfi(1)=rlatu(1)
+    lonfi(1)=rlonv(1)
+    cufi(1)=cu(1)
+    cvfi(1)=cv(1)
+    airefi(1)=aire(1,1)
+  ENDIF ! of IF (klon_glo>1)
+
+!$OMP PARALLEL 
+  ! Now generate local lon/lat/cu/cv/area arrays
+  CALL initcomgeomphy
 
   offset = klon_mpi_begin - 1
-  airephy(1:klon_omp) = parea(offset+klon_omp_begin:offset+klon_omp_end)
-  cuphy(1:klon_omp) = pcu(offset+klon_omp_begin:offset+klon_omp_end)
-  cvphy(1:klon_omp) = pcv(offset+klon_omp_begin:offset+klon_omp_end)
-  rlond(1:klon_omp) = plon(offset+klon_omp_begin:offset+klon_omp_end)
-  rlatd(1:klon_omp) = plat(offset+klon_omp_begin:offset+klon_omp_end)
+  airephy(1:klon_omp) = airefi(offset+klon_omp_begin:offset+klon_omp_end)
+  cuphy(1:klon_omp) = cufi(offset+klon_omp_begin:offset+klon_omp_end)
+  cvphy(1:klon_omp) = cvfi(offset+klon_omp_begin:offset+klon_omp_end)
+  rlond(1:klon_omp) = lonfi(offset+klon_omp_begin:offset+klon_omp_end)
+  rlatd(1:klon_omp) = latfi(offset+klon_omp_begin:offset+klon_omp_end)
 
     ! suphel => initialize some physical constants (orbital parameters,
@@ -86,8 +140,8 @@
   CALL suphel
 
-  !$OMP END PARALLEL
-
-    ! check that physical constants set in 'suphel' are coherent
-    ! with values set in the dynamics:
+!$OMP END PARALLEL
+
+  ! check that physical constants set in 'suphel' are coherent
+  ! with values set in the dynamics:
   IF (rday/=punjours) THEN
     WRITE (lunout, *) 'iniphysiq: length of day discrepancy!!!'
@@ -142,15 +196,9 @@
 
   ! Additional initializations for aquaplanets
-  !$OMP PARALLEL
+!$OMP PARALLEL
   IF (iflag_phys>=100) THEN
     CALL iniaqua(klon_omp, rlatd, rlond, iflag_phys)
   END IF
-  !$OMP END PARALLEL
-
-  ! RETURN
-  ! 9999  CONTINUE
-  ! abort_message ='Cette version demande les fichier rnatur.dat
-  ! & et surf.def'
-  ! CALL abort_gcm (modname,abort_message,1)
+!$OMP END PARALLEL
 
 END SUBROUTINE iniphysiq
Index: LMDZ5/branches/testing/libf/phylmd/lmdz1d.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/lmdz1d.F90	(revision 2220)
+++ LMDZ5/branches/testing/libf/phylmd/lmdz1d.F90	(revision 2258)
@@ -10,5 +10,4 @@
       USE ioipsl, only: ju2ymds, ymds2ju, ioconf_calendar
       use phys_state_var_mod
-      use comgeomphy
       use dimphy
       use surface_data, only : type_ocean,ok_veget
@@ -203,9 +202,7 @@
 !  Call to physiq
 !---------------------------------------------------------------------
-      integer, parameter :: longcles=20
       logical :: firstcall=.true.
       logical :: lastcall=.false.
       real :: phis    = 0.0
-      real :: clesphy0(longcles) = 0.0
       real :: dpsrf 
 
@@ -365,5 +362,5 @@
 !---------------------------------------------------------------------
 
-      call conf_gcm( 99, .TRUE. , clesphy0 )
+      call conf_gcm( 99, .TRUE. )
 !-----------------------------------------------------------------------
 !   Choix du calendrier
@@ -473,5 +470,4 @@
       call init_phys_lmdz(1,1,llm,1,(/1/))
       call suphel
-      call initcomgeomphy
       call infotrac_init 
 
@@ -608,5 +604,5 @@
       rlon_rad(:)=rlon(:)*rpi/180.
 
-      call iniphysiq(ngrid,llm,rday,day_ini,timestep,                        &
+      call iniphysiq(iim,jjm,llm,rday,day_ini,timestep,                        &
      &     rlat_rad,rlon_rad,airefi,zcufi,zcvfi,ra,rg,rd,rcpd,(/1/))
       print*,'apres iniphysiq'
@@ -618,5 +614,4 @@
 ! Ecriture du startphy avant le premier appel a la physique.
 ! On le met juste avant pour avoir acces a tous les champs
-! NB: les clesphy0 seront remplies dans phyredem d'apres les flags lus dans gcm.def
 
       if (ok_writedem) then
@@ -673,6 +668,11 @@
         zpic = zpicinp
         ftsol=tsurf
+        nsw=6 ! on met le nb de bandes SW=6, pour initialiser
+              ! 6 albedo, mais on peut quand meme tourner avec
+              ! moins. Seules les 2 ou 4 premiers seront lus
         falb1 = albedo                            
         falb2 = albedo                            
+        falb_dir=albedo
+        falb_dif=albedo
         rugoro=rugos 
         t_ancien(1,:)=temp(:)
@@ -859,5 +859,5 @@
      &              firstcall,lastcall,                                     &
      &              day,time,timestep,                                      &
-     &              plev,play,phi,phis,presnivs,clesphy0,                   &
+     &              plev,play,phi,phis,presnivs,                            &
      &              u,v,temp,q,omega2,                                      &
      &              du_phys,dv_phys,dt_phys,dq,dpsrf,                        &
